// Agent auctioneer in project auction_ag

/* Initial beliefs and rules */

/* Initial goals */
!start.
/* Plans */

+!start : .my_name(Name) <-
      .wait(10000); .print("starting");
       +plays(initiator);
       .broadcast(tell,plays(initiator));
       !launch_auctions;
       .

+!launch_auctions : .findall(participant(A),plays(participant)[source(A)],L) & .length(L,Length) & Length >= 2
//+!launch_auctions : plays(participant)[L] & .length(L,2)
       <-
       .print("starting auction with ",L);
       !!cfp(flight_ticket(paris, athens,"15/12/2016"),"now + 10 seconds");
       !cfp(flight_ticket(athens, paris,"18/12/2016"),"now + 12 seconds").

-!launch_auctions
       <- .wait(500); !launch_auctions.

+!cfp(Service, Time) : true <-
       .broadcast(tell, auction(service, Service));
       .at(Time, {+!decide(Service)}).

+!decide(Service)     // receives bids and checks for new winner
       :  .findall(b(V,A),bid(Service,V)[source(A)],L)
       <- .min(L,b(V,W));
          .print("Winner for ", Service, " is ",W," with ", V, ". Options=",L);
          .broadcast(tell, winner(Service,W)).

{ include("$jacamoJar/templates/common-cartago.asl") }
{ include("$jacamoJar/templates/common-moise.asl") }

// uncomment the include below to have a agent that always complies with its organization
//{ include("$jacamoJar/templates/org-obedient.asl") }
